## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 6;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global giacver 1.9.0.59
%global pypi_name  giacpy

%global with_check  1

# Architectures currently not supported
# http://xcas.e.ujf-grenoble.fr/XCAS/viewtopic.php?f=19&t=1723
ExcludeArch: aarch64 %{power64} s390x

Name:           python-%{pypi_name}
Version:        0.7.3
Release:        %autorelease
Summary:        Python binding for Giac
License:        GPL-2.0-or-later
URL:            http://webusers.imj-prg.fr/~frederic.han/xcas/giacpy/
Source0:        %pypi_source
BuildRequires:  giac-devel >= %{giacver}
BuildRequires:  giac-doc   >= %{giacver}
BuildRequires:  gmp-devel, qt5-qtsvg-devel

# math.sin(a) test fails randomly
Patch0:         %{name}-skip_math_sin.patch

%description
A Cython frontend to the c++ library Giac (Computer Algebra System).

%package -n     python3-%{pypi_name}
Summary:        Python3 binding for Giac
%{?python_provide:%python_provide python3-%{pypi_name}}

BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros
BuildRequires:  python3-setuptools
BuildRequires:  %{_bindir}/cython
BuildRequires:  libqcas-devel
Requires:       python3dist(cython)
Requires:       giac-doc >= %{giacver}
Obsoletes:      python2-%{pypi_name} < 0:%{version}

%description -n python3-%{pypi_name}
A Cython frontend to the c++ library Giac (Computer Algebra System).

%package -n     python3-%{pypi_name}-devel
Summary:        Development libraries of python3-%{pypi_name}
Requires:       python3-%{pypi_name}%{?_isa}

%description -n python3-%{pypi_name}-devel
Development libraries of Python3 %{pypi_name}.

%prep
%autosetup -n %{pypi_name}-%{version} -p1

rm -rf *.egg-info

# Remove the cythonized files in order to regenerate them during build.
rm $(grep -rl '/\* Generated by Cython')

%generate_buildrequires
%pyproject_buildrequires -x tests

%build
export CFLAGS="%{optflags} %(pkg-config --cflags Qt5Xml Qt5Widgets)"
%pyproject_wheel -C--global-option=--enable-qcas

%install
%pyproject_install
%pyproject_save_files %{pypi_name}

rm -f $RPM_BUILD_ROOT%{python3_sitearch}/%{pypi_name}/giacpy.cpp

%if 0%{?with_check}
%check
pushd build/lib.linux-*
export PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitearch}
%{py3_test_envvars} %{python3} -m doctest ../../%{pypi_name}/%{pypi_name}.pyx -v
popd
%endif

%files -n python3-%{pypi_name} -f %{pyproject_files}
%doc README.txt
%exclude %{python3_sitearch}/%{pypi_name}/*.h

%files -n python3-%{pypi_name}-devel
%{python3_sitearch}/%{pypi_name}/*.h

%changelog
* Fri Jul 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Jul 10 2024 Antonio Trande <sagitter@fedoraproject.org> - 0.7.3-5
- Switch to pyproject macros

* Fri Jun 07 2024 Python Maint <python-maint@redhat.com> - 0.7.3-4
- Rebuilt for Python 3.13

* Fri Jan 26 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Sep 20 2023 Antonio Trande <sagitter@fedoraproject.org> - 0.7.3-1
- Release 0.7.3 (rhbz#2239905)

* Sun Aug 13 2023 Antonio Trande <sagitter@fedoraproject.org> - 0.7.2-3
- Another fix for Cython request

* Tue Aug 01 2023 Antonio Trande <sagitter@fedoraproject.org> - 0.7.2-2
- Fix Requires package

* Tue Aug 01 2023 Antonio Trande <sagitter@fedoraproject.org> - 0.7.2-1
- Release 0.7.2

* Fri Jul 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Tue Jun 13 2023 Python Maint <python-maint@redhat.com> - 0.7.1-3
- Rebuilt for Python 3.12

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Nov 22 2022 Antonio Trande <sagitter@fedoraproject.org> - 0.7.1-1
- Release 0.7.1

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Wed Jun 22 2022 Charalampos Stratakis <cstratak@redhat.com> - 0.7.0-13
- Fix FTBFS with setuptools >= 62.1

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 0.7.0-12
- Rebuilt for Python 3.11

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sat Jun 12 2021 Antonio Trande <sagitter@fedoraproject.org> - 0.7.0-9
- Rebuilt for giac-1.7.0.13

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 0.7.0-8
- Rebuilt for Python 3.10

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sun Jul 19 2020 sagitter <sagitter@fedoraproject.org> - 0.7.0-5
- Rebuild for giac-1.6.0.7

* Wed Jun 24 2020 sagitter <sagitter@fedoraproject.org> - 0.7.0-4
- BuildRequires python3-setuptools explicitly

* Tue May 26 2020 Miro Hrončok <miro@hroncok.cz> - 0.7.0-3
- Rebuilt for Python 3.9

* Wed Feb 05 2020 sagitter <sagitter@fedoraproject.org> - 0.7.0-2
- Skip math.sin(a) test

* Wed Feb 05 2020 sagitter <sagitter@fedoraproject.org> - 0.7.0-1
- Release 0.7.0

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Tue Sep 17 2019 sagitter <sagitter@fedoraproject.org> - 0.6.9-1
- Release 0.6.9

* Mon Sep 16 2019 sagitter <sagitter@fedoraproject.org> - 0.6.8-8
- Fix doctest failure

* Sun Sep 15 2019 sagitter <sagitter@fedoraproject.org> - 0.6.8-7
- Obsoletes tag is now versioned

* Sat Sep 14 2019 sagitter <sagitter@fedoraproject.org> - 0.6.8-6
- Fix Release tag

* Sat Sep 14 2019 sagitter <sagitter@fedoraproject.org> - 0.6.8-5
- Rebuild for giac-1.5.0.63

* Mon Aug 19 2019 Miro Hrončok <miro@hroncok.cz> - 0.6.8-4
- Rebuilt for Python 3.8

* Fri Jul 26 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.8-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Jun 07 2019 Charalampos Stratakis <cstratak@redhat.com> - 0.6.8-2
- Recythonize the sources

* Wed Jun 05 2019 sagitter <sagitter@fedoraproject.org> - 0.6.8-1
- Release 0.6.8

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.7-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Thu Oct 11 2018 sagitter <sagitter@fedoraproject.org> - 0.6.7-2
- Fix build commands

* Thu Oct 11 2018 sagitter <sagitter@fedoraproject.org> - 0.6.7-1
- Release 0.6.7

* Mon Aug 27 2018 sagitter <sagitter@fedoraproject.org> - 0.6.6-5
- Fix Cython requests

* Mon Aug 27 2018 sagitter <sagitter@fedoraproject.org> - 0.6.6-4
- Deprecate Python2 on fedora 30+

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.6-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Tue Jun 19 2018 Miro Hrončok <miro@hroncok.cz> - 0.6.6-2
- Rebuilt for Python 3.7

* Sat Feb 10 2018 sagitter <sagitter@fedoraproject.org> - 0.6.6-1
- Release 0.6.6

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Feb 03 2018 sagitter <sagitter@fedoraproject.org> - 0.6.5-3
- Rebuild for giac-1.4.9.45

* Sat Jan 27 2018 sagitter <sagitter@fedoraproject.org> - 0.6.5-2
- Fix dependencies

* Thu Jan 18 2018 sagitter <sagitter@fedoraproject.org> - 0.6.5-1
- New package
